#include "SimpleModbusRtu_mega2560_rs485.h"

#define MODBUS_SLAVE_ADDRESS 1

// 10 * 8 = 80 coils starting at modbus address 0 (for coil function codes)
unsigned char mdcoil[10];

// 10 16-bit registers starting at modbus address 0 (for register function codes)
unsigned short mdRegister[10];

void setup() 
{
    usart1init(57600);
    startSimpleModbus(MODBUS_SLAVE_ADDRESS, mdRegister, mdcoil);

    for(char i=22;i<=37;i++)  pinMode(i,INPUT);
    for(char i=38;i<=51;i++)  pinMode(i,OUTPUT);
}

void loop() 
{
    unsigned short state = 0;

    // The following code assumes register access for bit data
    // to reduce the size and number of modbus queries

    // Syncronize modbus memory with digital inputs 22 ~ 37
    for(char i=37;i>=22;i--)
    {
        state <<=1;
        state |= digitalRead(i);
    }
    mdRegister[1] = state;

    // Syncronize modbus memory with digital outputs 38 ~ 51
    for(char i=38;i<=51;i++)
    {
        digitalWrite(i,mdRegister[0] & (0x01 << (i-38)) ? 1 : 0);
    }
}
